//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//


var gOrigBlog;

function fillFields(title) {
    if(title) {
        gOrigBlog = title;
        _fillFields();
    }
    else if(window.arguments) {
        gOrigBlog = window.arguments[0];
        window.setTimeout("_fillFields();",0);
    }
}


function _fillFields() {
    var title = gOrigBlog;
    if(!title) return;

    var account = flock.blog.service.getAccount(title);
    var api = flock.blog.service.getBlogAPI(title);

    $("blog-title").value = account.title;
    $("blog-username").value = account.username;
    $("blog-password").value = account.password;
    $("blog-blogid").value = api.blogID;
    $("blog-uri").value = api.apiLink;

    updateDropdown(api.name);
}

function updateDropdown(apiname) {
    $("blog-api-menu").value=apiname;
}

function validateAccount() {
    var name = $("blog-api-menu").value;
    var strbundle = document.getElementById("blogStringBundle");
    if(name=="unknown") {
        return strbundle.getString("flock.blog.account.select");
    }
    var t = $("blog-title").value;
    if(t=="") {
        return strbundle.getString("flock.blog.account.title");
    }
    return null;
}

function saveAccount() {
    var msg = validateAccount();

    if(msg) {
        alert(msg);
        return;
    }

    //var ds = flock.blog.settings.ds;
    var t = $("blog-title").value;
    var bloguri = FLOCK_BLOG_RDF_SETTINGS + ":" + t;

    var u = $("blog-username").value;
    var p = $("blog-password").value;
    var b = $("blog-blogid").value;
    var uri = $("blog-uri").value;


    var apiName = $("blog-api-menu").selectedItem.value;
    if(apiName && apiName.length) {
        var api = new BlogAPI();
        api.name = apiName;
        api.apiLink = uri;
        api.editLink = "";
        api.blogID = b;
        var blogSettings = flock.blog.settings;
        var uri = gOrigBlog;
        var account = blogSettings.getAccount(uri);
        account.username = u;
        account.password = p;
        // blogSettings.saveAccount(account);
        flock.blog.service.saveAccount(account);
        account.setBlogAPI(api);
    }
    window.close();
}

