// vim: foldmethod=marker
flock.rdf = {/*{{{*/
    // feed them well though words
    // show them what they want
    // tell them you love them
    // and they will fuck you all night long
}/*}}}*/

flock.rdf.__defineGetter__('service', function () {/*{{{*/
    return flock.xpcom.getService(
        '@mozilla.org/rdf/rdf-service;1',
        'nsIRDFService'
    );
});/*}}}*/

flock.rdf.getResource = function (aStr) {/*{{{*/
    return flock.rdf.service.GetResource(aStr);
}/*}}}*/
flock.rdf.getLiteral = function (aStr) {/*{{{*/
    return flock.rdf.service.GetResource(aStr);
}/*}}}*/

flock.rdf.isResource = function (aRsrc) {/*{{{*/
    try {
        aRsrc.QueryInterface(Components.interfaces.nsIRDFResource);
        return true;
    }
    catch (e) {
        return false;
    }
}/*}}}*/

flock.rdf.dump = function (aDataSource) {/*{{{*/
    var serializer = Components.classes["@mozilla.org/rdf/xml-serializer;1"]
        .createInstance(Components.interfaces.nsIRDFXMLSerializer);
    serializer.init(aDataSource);
    serializer.QueryInterface(Components.interfaces.nsIRDFXMLSource).Serialize({
        close : function(){dump("\n");},
        flush : function(){},
        write : function (buffer,count){ dump (buffer); return count; },
        writeFrom : function (stream,count){},
        isNonBlocking: false
    });
}/*}}}*/

flock.rdf.repr = function (aSomething) {/*{{{*/
    var node = aSomething;
    try { 
        var value = node.QueryInterface(
            Components.interfaces.nsIRDFResource
        ).ValueUTF8;
        value = value.replace(
            'http://www.w3.org/1999/02/22-rdf-syntax-ns#', 
            'W3:'
        );
        value = value.replace(
            'http://home.netscape.com/NC-rdf#', 
            'NS:'
        );
        value = value.replace(
            'http://developer.mozilla.org/rdf/vocabulary/forward-proxy#', 
            'FP:'
        );
        value = value.replace(
            'http://flock.com/rdf#', 
            'FL:'
        );
        return value;
    }
    catch (e) { }

    try { 
        var date = node.QueryInterface(
            Components.interfaces.nsIRDFDate
        );
        return 'date:'+date.Value;
    }
    catch (e) { }

    try { 
        var blob = node.QueryInterface(
            Components.interfaces.nsIRDFBlob
        );
        return 'blob: length'+blob.Length;
    }
    catch (e) { }

    try { 
        var int = node.QueryInterface(
            Components.interfaces.nsIRDFInt
        );
        return 'int:'+int.Value;
    }
    catch (e) { }

    try { 
        var literal = node.QueryInterface(
            Components.interfaces.nsIRDFLiteral
        );
        return '"'+literal.Value+'"';
    }
    catch (e) { }
    
    return 'unknown:'+node; 
}/*}}}*/

flock.rdf.getValue = function (aSomething) {/*{{{*/
    var node = aSomething;
    try { 
        var value = node.QueryInterface(
            Components.interfaces.nsIRDFResource
        ).ValueUTF8;
        return value;
    }
    catch (e) { }

    try { 
        var date = node.QueryInterface(
            Components.interfaces.nsIRDFDate
        );
        return date.Value;
    }
    catch (e) { }
    
    try { 
        var int = node.QueryInterface(
            Components.interfaces.nsIRDFInt
        );
        return int.Value;
    }
    catch (e) { }

    try { 
        var literal = node.QueryInterface(
            Components.interfaces.nsIRDFLiteral
        );
        return literal.Value;
    }
    catch (e) { }
    
    return node; 
}/*}}}*/


flock.rdf.addDataSources = function (aElement, aDataSources) {/*{{{*/
    for (var i = 0; i < aDataSources.length; ++i) {
        aElement.database.AddDataSource(aDataSources[i]);
    }
};/*}}}*/

flock.rdf.removeDataSources = function (aElement, aDataSources) {/*{{{*/
    for (var i = 0; i < aDataSources.length; ++i) {
        var sources = aElement.database.GetDataSources();
        //var count = 0;
        //while (sources.hasMoreElements()) {
        //    count++;
        //    XXX('DATASOURCE', sources.getNext());
        //}
        //XXX('DATASOURCE COUNT', count);
        aElement.database.RemoveDataSource(aDataSources[i]);
    }
};/*}}}*/

flock.rdf.clearDataSources = function (aElement) {/*{{{*/
    var sources = aElement.database.GetDataSources();
    while (sources.hasMoreElements()) {
        var source = sources.getNext();
        aElement.database.RemoveDataSource(source);
    }
};/*}}}*/


flock.rdf.RDFObserver = function (aOpts) {/*{{{*/
    if (aOpts && aOpts.isDebug) {
        ["onAssert", "onChange", "onMove", "onUnassert"].forEach(function (aM) {
            this["debug_" + aM] = this.debug_rdf;
        }, this);
    }
    flock.Base.call(this, aOpts);
};/*}}}*/
dojo.inherits(flock.rdf.RDFObserver, flock.Base);
dojo.lang.extend(flock.rdf.RDFObserver, {
    // nsIRDFObserver
    onAssert: function (aDataSource, aSource, aProperty, aTarget) {/*{{{*/

    },/*}}}*/
    debug_rdf: function (aFunc, aFuncName) {/*{{{*/
        var out = function () {
            var args = flock.lang.toArray(arguments);
            args.shift();
            var args = args.map(flock.rdf.getValue);
            var debugArgs = ["DEBUG", aFuncName, "DS"].concat(args);
            XXX.apply(this, debugArgs);
            return aFunc.apply(this, arguments);
        };
        return out;
    },/*}}}*/
    onBeginUpdateBatch: function (aDataSource) {/*{{{*/

    },/*}}}*/
    onChange: function (aDataSource, aSource, aProperty, aOldTarget, aNewTarget) {/*{{{*/

    },/*}}}*/
    onEndUpdateBatch: function (aDataSource) {/*{{{*/

    },/*}}}*/
    onMove: function (aDataSoure, aOldSource, aNewSource, aProperty, aTarget) {/*{{{*/

    },/*}}}*/
    onUnassert: function (aDataSource, aSource, aProperty, aTarget) {/*{{{*/

    },/*}}}*/
});

// XXX andy: should write a generic batcher mixin
flock.rdf.BatchedRDFObserver = function (aOpts) {/*{{{*/
    this._timers = {};
    this._batches = {};
    if (aOpts && aOpts.isDebug) {
        ["onAssert", "onChange", "onMove", "onUnassert"].forEach(function (aM) {
            this["debug_" + aM + "Batch"] = function (aFunc, aFuncName) {
                return function () {
                    XXX('DEBUG', aFuncName);
                    return aFunc.apply(this, arguments);
                }
            }
        }, this);
    }
    flock.rdf.RDFObserver.call(this, aOpts);
    this.initBatch();
}/*}}}*/
dojo.inherits(flock.rdf.BatchedRDFObserver, flock.rdf.RDFObserver);
dojo.lang.extend(flock.rdf.BatchedRDFObserver, {
    _delay: 300,
    _timers: null,
    _batches: null,
    initBatch: function () {/*{{{*/
        ["onAssert","onChange","onMove","onUnassert"].forEach(function (aM) {
            this[aM] = flock.lang.decorate(
                this[aM],
                this.batchWrapper,
                this,
                aM
            );
        }, this);
    },/*}}}*/
    batchWrapper: function (aFunc, aFuncName) {/*{{{*/
        return function () {
            aFunc.apply(this, arguments);
            this.batch(aFuncName, arguments);
        }
    },/*}}}*/
    updateTimer: function (aFunc) {/*{{{*/
        if (this._timers[aFunc]) {
            clearTimeout(this._timers[aFunc]);
        }
        var inst=this;
        this._timers[aFunc] = setTimeout(
            function() { inst.callBatched( aFunc ); },
            this._delay );
    },/*}}}*/
    clearTimer: function (aFunc) {/*{{{*/
        if (!aFunc) {
            this._timers.forEach(clearTimeout);
            return;
        }
        if (this._timers[aFunc]) {
            clearTimeout(this._timers[aFunc]);
        }
    },/*}}}*/
    callBatched: function (aFunc) {/*{{{*/
        var batch = [];
        if (this._batches[aFunc]) { 
            batch = this._batches[aFunc];
            this._batches[aFunc] = [];
        }
        if (this[aFunc + 'Batch']) {
            this[aFunc + 'Batch'].call(this, batch);
        }
    },/*}}}*/
    batch: function (aFunc, aArgs) {/*{{{*/
        this.updateTimer(aFunc);
        if (!this._batches[aFunc]) this._batches[aFunc] = [];
        var args = flock.lang.toArray(aArgs);
        this._batches[aFunc].push(args);
    },/*}}}*/
    debug_batch: function (aFunc, aFuncName) {/*{{{*/
        return function () {
            XXX('DEBUG', aFuncName, arguments[0]);
            return aFunc.apply(this, arguments);
        }
    },/*}}}*/
});


flock.rdf.RDFSniffer = function (aOpts) {
    flock.rdf.BatchedRDFObserver.call(this, aOpts);
    this.translators = this.translators || {};
    this.storage = this.storage || {};
};
dojo.inherits(flock.rdf.RDFSniffer, flock.rdf.BatchedRDFObserver);
dojo.lang.extend(flock.rdf.RDFSniffer, {
    translators: null,
    storage: null,
});


