flock.favorites = {
    // fashion feeds our identities
    // this love like any other
};

// XXX andy: this should be refactored, it is ugly
flock.favorites.__defineGetter__("bundle", function () {
    // RAJ -- rationalize this into a common string bundle
    var bundle;
    bundle = document.getElementById('bundle_favorites');
    if (!bundle)
        return document.getElementById("strBundle");
    else
       return bundle;

});

flock.favorites.__defineGetter__("service", function () {
    if (flock.favorites._service) return flock.favorites._service;
    flock.favorites._service = flock.xpcom.getService(
        '@mozilla.org/rdf/datasource;1?name=flock-favorites',
        'flockIFavoritesService'
    );
    return flock.favorites._service;
});
flock.favorites.__defineGetter__("properties", function () {
    if (flock.favorites._properties) return flock.favorites._properties;
    flock.favorites._properties = Components.interfaces.flockIFavoriteProperties;
    return flock.favorites._properties;
});
flock.favorites.__defineGetter__("webService", function () {
    // XXX andy: this is not caching right now because presumably it can
    //           change
    return flock.favorites.service.webService;
});

// Web Service
flock.favorites.supportsField = function (aField) {
    if (!flock.favorites.webService) return false;
    return (flock.favorites.service.webService.supportedFields 
        & flock.favorites.properties['FIELD_' + aField.toUpperCase()]);
};


// Collections
flock.favorites.getCollection = function (aSomething) {
    if (!aSomething) return null;
    if (aSomething.isCollection) {
        return aSomething;
    }
    if (typeof aSomething == "string") {
        // try to get it as a name, then as a resource url
        if (flock.favorites.service.isCollection(aSomething)) {
            return new flock.favorites.Collection({
                name: aSomething
            });
        }
        aSomething = flock.rdf.getResource(aSomething);
    }
    if (flock.rdf.isResource(aSomething)) {
         //else as a resource
         if (flock.favorites.service.isCollectionResource(aSomething)) {
             var name =  flock.favorites.service.getCollectionName(aSomething);
             return new flock.favorites.Collection({
                 name: name,
                 resource: aSomething
             });
        }
    }
    return null;
}
flock.favorites.isCollection = function (aCollection) {
    return (flock.favorites.getCollection(aCollection) != null);
}
flock.favorites.createCollection = function (aName) {
    var strBundle = flock.favorites.bundle;
    if (aName == null) {
        var newTitle = strBundle.getString("flock.favorites.collection.new.untitled");
        while (flock.favorites.isCollection(newTitle)) {
            newTitle = newTitle.replace(/[\d]*$/, function (aMatch) {
                 if (!aMatch) return " 2";
                 else {
                    aMatch = parseInt(aMatch);
                    aMatch++;
                    return aMatch;
                 }
            });
        }

        var rv = flock.dialog.prompt({
            isDebug: true,
            message: strBundle.getString("flock.favorites.collection.new.title"),
            validators: [
                function (aForm) {
                    var f = aForm.fields.name.value;
                    if (f == "") {
                        aForm.showError(strBundle.getString("flock.favorites.collection.error.blank"), ["name"]);
                        return false;
                    }
                    if (flock.favorites.isCollection(f)) {
                        aForm.showError(strBundle.getString("flock.favorites.collection.error.exists"), ["name"]);
                        return false;
                    }
                    return true;
                }
            ],
            fields: [
                {label: strBundle.getString("flock.favorites.name"), input: {
                    id: "name",
                    value: newTitle
                }}
            ],
        });
        if (!rv) return;
        aName = rv.name;
    }
    XXX('aName',aName);
    if (flock.favorites.service.createCollection(aName)) return aName;
}
flock.favorites.createCollectionFrom = function (aItems) {
    var collection = flock.favorites.createCollection();
    if (!collection) return null;
    flock.favorites.addItemsToCollection(aItems, collection);
    return collection;
};
flock.favorites.removeCollection = function (aCollection, aForce) {
    aCollection = flock.favorites.getCollection(aCollection);
    var strBundle = flock.favorites.bundle;
    if (!aForce) {
        var confirmed = flock.dialog.confirm(strBundle.getString('flock.favorites.collection.delete.confirm'));
        
        if (!confirmed) return;
    }
    flock.favorites.service.removeCollection(aCollection.name);
};
flock.favorites.renameCollection = function (aCollection, aNewName) {
    var collection = flock.favorites.getCollection(aCollection);
    var strBundle = flock.favorites.bundle;
    var name = aNewName;
    if (!name) {
        // XXX andy: this code has been reused a couple times so far, 
        //           probably worth a refactor
        var rv = flock.dialog.prompt({
            isDebug: true,
            message: strBundle.getString("flock.favorites.collection.rename.title"),
            validators: [
                function (aForm) {
                    var f = aForm.fields.name.value;
                    if (f == "") {
                        aForm.showError(strBundle.getString("flock.favorites.collection.error.blank"), ["name"]);
                        return false;
                    }
                    if (flock.favorites.isCollection(f)) {
                        aForm.showError(strBundle.getString("flock.favorites.collection.error.exists"), ["name"]);
                        return false;
                    }
                    return true;
                }
            ],
            fields: [
                {label: strBundle.getString("flock.favorites.name"), input: {
                    id: "name",
                    value: collection.name
                }}
            ],
        });
        if (!rv) return;
        var name = rv.name;
    }
    flock.favorites.service.renameCollection(collection.name, name);
}
flock.favorites.editCollection = function (aCollection, aProps) {
    var collection = flock.favorites.getCollection(aCollection);
    var strBundle = flock.favorites.bundle;
    var props = aProps;
    if (!props) {
        var rv = flock.dialog.prompt({
            isDebug: true,
            message: strBundle.getString("flock.favorites.collection.properties.title"),
            validators: [
                function (aForm) {
                    var f = aForm.fields.name.value;
                    if (f == "") {
                        aForm.showError(strBundle.getString("flock.favorites.collection.error.blank"), ["name"]);
                        return false;
                    }
                    if (flock.favorites.isCollection(f)) {
                        aForm.showError(strBundle.getString("flock.favorites.collection.error.exists"), ["name"]);
                        return false;
                    }
                    return true;
                }
            ],
            fields: [
                {label: strBundle.getString("flock.favorites.name"), input: {
                    id: "name",
                    value: collection.name
                }}
            ],
        });
        if (!rv) return;
        var props = rv;
    }
    // XXX andy: we should have an update collection call, but for now the
    //           only call is to rename one, so we will just have to live with
    //           that :(
    flock.favorites.service.renameCollection(collection.name, props.name);
}

flock.favorites.viewFeedsForCollection = function (aCollection, aWhere) {
    var collection = flock.favorites.getCollection(aCollection);
    var feedList = [];
    for (var i = 0; i < collection.items.length; ++i) {
        var item = collection.items[i];
        XXX('FOR EACH ITEM', item);
        if (flock.favorites.isFeed(item)) {
            XXX('ITS A FEED');
            feedList.push(item.url);
        }
        else if (item.hasFeeds) {
            XXX('IT HAS FEEDS');
            for (var j = 0; j < item.feeds.length; ++j) {
                XXX('FOREACH FEED');
                feedList.push(item.feeds[j].url);
            }
        }
    }
    flock.browser.openFeeds(feedList, aWhere);
};
flock.favorites.refreshFeedsForCollection = function (aCollection) {
    var collection = flock.favorites.getCollection(aCollection);
    var feedList = [];
    for (var i = 0; i < collection.items.length; ++i) {
        var item = collection.items[i];
        if (flock.favorites.isFeed(item)) {
            feedList.push(item.url);
        }
        else if (item.hasFeeds) {
            for (var j = 0; j < item.feeds.length; ++j) {
                feedList.push(item.feeds[j].url);
            }
        }
    }
    flock.feed.refreshFeeds(feedList);
};
flock.favorites.viewFeeds = function (aItemList, aWhere) {
    var feedList = flock.favorites.getFeedList(aItemList);
    flock.browser.openFeeds(feedList, aWhere);
};
flock.favorites.getFeedList = function (aItemList) {
    var feedList = [];
    for (var i = 0; i < aItemList.length; ++i) {
        var item = aItemList[i];
        XXX('FOR EACH ITEM', item);
        if (flock.favorites.isFeed(item)) {
            item = flock.favorites.getFeed(item);
            XXX('ITS A FEED');
            feedList.push(item.url);
        }
        else {
            item = flock.favorites.getFavorite(item);
            if (item.hasFeeds) {
                XXX('IT HAS FEEDS');
                for (var j = 0; j < item.feeds.length; ++j) {
                    XXX('FOREACH FEED');
                    feedList.push(item.feeds[j].url);
                }
            }
        }
    }
    return feedList;
};
flock.favorites.getFeedData = function (aItem) {
    var fav = flock.favorites.getFavorite(aItem);
    var feedList = flock.favorites.getFeedList([fav]);
    var feeds = flock.lang.unique(feedList);
    feeds = feeds.map(function (aVal) {
        var feed = aVal;
        if (typeof feed == "string") var url = feed;
        else if (feed.url) var url = feed.url;
        return url;
    });
    var feedsUrl = flock.feed.service.joinFeedsURLs(feeds.length, feeds);
    XXX('feedsUrl', feedsUrl);
    var dummy = {value: 15}
    var data = flock.feed.service.getFeedData(feedsUrl, dummy);
    return data;
};
flock.favorites.refreshFeeds = function (aItemList) {
    var feedList = [];
    for (var i = 0; i < aItemList.length; ++i) {
        var item = aItemList[i];
        if (flock.favorites.isFeed(item)) {
            item = flock.favorites.getFeed(item);
            feedList.push(item.url);
        }
        else {
            item = flock.favorites.getFavorite(item);
            if (item.hasFeeds) {
                for (var j = 0; j < item.feeds.length; ++j) {
                    feedList.push(item.feeds[j].url);
                }
            }
        }
    }
    feedList = feedList.map(function (aVal) {
        var feed = aVal;
        if (typeof feed == "string") var url = feed;
        else if (feed.url) var url = feed.url;
        return url;
    });
    flock.feed.refreshFeeds(feedList);

};
flock.favorites.openCollectionInTabs = function (aCollection) {
    var collection = flock.favorites.getCollection(aCollection);
    for (var i = 0; i < collection.items.length; ++i) {
        flock.browser.open(collection.items[i].url, 'tab');
    }
    // aCollection = flock.favorites.getCollection(aCollection)
    // for each item in aCollection.items
    //     flock.nav.open(item.url, 'tab');
}

// Generic-ish
flock.favorites.fields = function (aProps) {
    var fields = 0;
    for (field in aProps) {
        if (!flock.favorites.properties["FIELD_"+field.toUpperCase()]) continue;
        fields |= flock.favorites.properties["FIELD_"+field.toUpperCase()];
    }
    return fields;
}
flock.favorites.openItem = function (aItem, aWhere) {
    if (flock.favorites.isFeed(aItem)) {
        var item = flock.favorites.getFeed(aItem);
        flock.browser.openFeeds(item.url, aWhere);
    }
    else if (flock.favorites.isFavorite(aItem)) {
        var item = flock.favorites.getFavorite(aItem);
        flock.browser.open(item.url, aWhere);
    }
};

flock.favorites.isItemInParent = function (aItem, aParent) {
    var fav = flock.favorites.getFavorite(aItem);
    if (!fav) return false;
    if (flock.favorites.isCollection(aParent)) {
        var collection = flock.favorites.getCollection(aParent);
        if (flock.favorites.service.isFavoriteInCollection(fav.url, collection.name)) {
            return true;
        }
        return false;
    }
    if (flock.favorites.isFavorite(aParent)) {
        if (!flock.favorites.isFeed(fav.url)) return false;
        var parentFav = flock.favorites.getFavorite(aParent);
        if (parentFav.feeds.indexOf(fav.url) != -1) return true;
        return false;
    }
    return false;
}
flock.favorites.removeItemFromParent = function (aItem, aParent) {
    XXX('removeItemFromParent', aItem, aParent);
    if (!aParent) {
        var item = flock.favorites.getFavorite(aItem);
        // remove from library
        flock.favorites.service.removeFavorite(item.url);
    }
    else if (flock.favorites.isFavorite(aParent)) {
        var item = flock.favorites.getFeed(aItem);
        // remove from a favorite
        var parent = flock.favorites.getFavorite(aParent);
        XXX('SHIZZOA',parent.url);
        flock.favorites.service.removeFeedFromFavorite(item.url, parent.url);
    }
    else if (flock.favorites.isCollection(aParent)) {
        var item = flock.favorites.getFavorite(aItem);
        // remove from a collection
        var parent = flock.favorites.getCollection(aParent);
        flock.favorites.service.removeFavoriteFromCollection(item.url, parent.name);
    }
}

flock.favorites.renameItem = function (aItem, aNewName) {
    XXX('renameItem', aItem, aNewName);
    var strBundle = flock.favorites.bundle;
    if (flock.favorites.isFeed(aItem)) {
        var item = flock.favorites.getFeed(aItem);
        var message = strBundle.getString("flock.favorites.feed.rename.title");
    }
    else if (flock.favorites.isFavorite(aItem)) {
        var item = flock.favorites.getFavorite(aItem);
        var message = strBundle.getString("flock.favorites.favorite.rename.title");
    }
    else {
        XXX('ASD', 'I am neither feed nor vaorite');
        return;
    }
    
    var name = aNewName;
    if (!name) {
        // XXX andy: this code has been reused a couple times so far, 
        //           probably worth a refactor
        var rv = flock.dialog.prompt({
            isDebug: true,
            message: message,
            validators: [
                function (aForm) {
                    var f = aForm.fields.name.value;
                    if (f == "") {
                        aForm.showError(strBundle.getString("flock.favorites.error.blank"), ["name"]);
                        return false;
                    }
                    return true;
                }
            ],
            fields: [
                {label: strBundle.getString("flock.favorites.name"), input: {
                    id: "name",
                    value: item.name
                }}
            ],
        });
        if (!rv) return;
        var name = rv.name;
    }
    flock.favorites.editItem(item, {name: name});
}

flock.favorites.editDialog = function(aItem, aProps) {
    var strBundle = flock.favorites.bundle;
    // input - aItem (a favorite, a feed, or a string)
    // output - aProps is used to return changed values if dialog succeeds
    var message;
    var params = Array();

    if (flock.favorites.isFeed(aItem)) {
        params.item = flock.favorites.getFeed(aItem);
    	params.item.load();
        message = 'borked'; //strBundle.getString("flock.favorites.feed.properties.edit")
    } 
    else if (flock.favorites.isFavorite(aItem)) {
        params.item = flock.favorites.getFavorite(aItem);
    	params.item.load();
        message = 'borked'; //strBundle.getString("flock.favorites.favorite.properties.edit");
    }
    else if (aItem instanceof Array) {
        params.items = Array();
        for (var i=0; i<aItem.length; i++) {
            var item = flock.favorites.getFavorite(aItem[i]);
            if (item) {
                item.load();
                params.items.push(item);
            }
        }
        message = 'borked'; // strBundle.getString("flock.favorites.favorite.edit.multiple");
    }
    else {
        // when a user wants to edit what the properties are before they create the favorite
        params.item = aItem;
        message = 'borked'; // strBundle.getString("flock.favorites.favorite.properties.new");
    }

    dojo.lang.mixin(params.item, aProps);
    
    window.openDialog("chrome://browser/content/flock/favorites/favoritesEditor.xul", message, "modal,titlebar,centerscreen,resizable=no", params);
    
    if (params.rv) {
        // XXX refactor - modifying collections a favorite belongs to shouldn't happen in the dialog ...  JA
        if (params.rv.collections != undefined) {
            var collections = params.rv.collections;
            var RDFS = flock_getRDFService ();
            collections.hasMoreElements = function () {
                return this.length > 0;
            }
            collections.getNext = function () {
                return RDFS.GetResource (this.shift(0))
            }
            flock.favorites.service.setFavoriteCollections (aItem.url, collections);
        }
        dojo.lang.mixin(aProps, params.rv);
        return true;
    } else {
        return false;
    }
}

// XXX - the editItem/editDialog code does NOT work if you call with
// both aProps and aDetails set. -- it will not show the aProps in the
// dialog then overwrite them with the new settings -- ja

flock.favorites.editItem = function (aItem, aProps, aDetails) {
    if (flock.favorites.isFeed(aItem)) {
        var isFeed = true;
    }
    else {
        var isFeed = false;
    }
    if (!aProps || aDetails) {
        if (!aProps) { aProps = {}; }
        if (flock.favorites.editDialog(aItem, aProps, aDetails)) {
            aProps.fields = flock.favorites.fields(aProps);
            if (isFeed) {
                flock.favorites.service.setFeedProperties(aItem.url, aProps);
            }
            else {
                flock.favorites.service.updateFavorite(aItem.url, aProps);
            }
        }
    }
    else {
        aProps.fields = flock.favorites.fields(aProps);
        if (isFeed) {
            flock.favorites.service.setFeedProperties(aItem.url, aProps);
        }
        else {
            flock.favorites.service.updateFavorite(aItem.url, aProps);
        }
    }
}
flock.favorites.editMultipleItems = function (someItems) {
    var items = [];
    var aProps = {};
    for (var i=0; i<someItems.length; i++) {
        items.push(flock.favorites.getFavorite(someItems[i]));
    }
    
    if (flock.favorites.editDialog(items, aProps)){
        aProps.fields = flock.favorites.fields(aProps);
        for (var i=0; i<items.length; i++) {
            try {
                flock.favorites.service.updateFavorite(items[i].url, aProps);
            } catch (e) {}
        }
    }
    
}

flock.favorites.canFavoriteUrl = function (aUrl) {
    if (aUrl == "http://www.example.com/") return false;
    return true;
}

// XXX check
flock.favorites.__defineGetter__('currentAsFavorite', function () {
    var fav = {
        url: flock.browser.currentUrl,
        name: flock.browser.currentTitle,
        feed: (flock.browser.isFeedView 
                 || flock.favorites.isFeedDocument(flock.browser.currentDocument)
        ),
    };
    return fav;
});

flock.favorites.isFeedDocument = function (aDom) {
    return flock.feed.service.isFeed(aDom);   
};


// XXX make handle indexes
flock.favorites.addItemsToCollection = function (aItems, aCollection, aIndex) {
    for (var i = 0; i < aItems.length; ++i) {
        flock.favorites.addItemToCollection(aItems[i], aCollection);
    }
}
flock.favorites.addItemToCollection = function (aItem, aCollection, aDetails) {
    aItem = flock.favorites.getOrCreateFavorite(aItem, aDetails);
    aCollection = flock.favorites.getCollection(aCollection);
    if (!aCollection || !aItem) return;
    flock.favorites.service.addFavoriteToCollection(aItem.url, aCollection.name);
}

flock.favorites.reorderItemInParent = function (aItem, aParent, aIndex) {
    XXX('REORDER SOMETHINGGGGG');
    var fav = flock.favorites.getFavorite(aItem);
    if (flock.favorites.isFavorite(aParent)) {
        // not implemeneted yet
        return;
    }
    if (flock.favorites.isCollection(aParent)) {
        var collection = flock.favorites.getCollection(aParent);
        flock.favorites.service.orderFavoriteInCollection(
            fav.url, 
            collection.name,
            aIndex
        );
    }
}
flock.favorites.getIndexInCollection = function (aItem, aCollection) {
    var item = flock.favorites.getFavorite(aItem);
    var collection = flock.favorites.getCollection(aCollection);
    return flock.favorites.service.getFavoriteOrderInCollection(
        item.url, 
        collection.name
    );
};

// Favorites
// XXX make this support resources
flock.favorites.getFavorite = function (aSomething) {
    if (!aSomething) return null;
    if (aSomething.isFavorite) {
        return aSomething;
    }
    if (typeof aSomething == "string") {
        // try to get it as a url
        if (flock.favorites.service.isFavorite(aSomething)) {
            return new flock.favorites.Favorite({
                url: aSomething
            });
        }
    }
    if (aSomething.url) {
        if (flock.favorites.service.isFavorite(aSomething.url)) {
            return new flock.favorites.Favorite(aSomething);
        }
    }
    if (flock.rdf.isResource(aSomething)) {
        var str = aSomething.ValueUTF8;
        if (flock.favorites.service.isFavorite(str)) {
            return new flock.favorites.Favorite({url: str});
        }
    }
    return null;
}
flock.favorites.getOrCreateFavorite = function (aItem, aDetails) {
    var fav = flock.favorites.getFavorite(aItem);
    if (fav) return fav;
    
    var url = null;
    var name = null;
    if (typeof aItem == "string") {
        url = aItem;
    }
    else if (aItem.url) {
        url = aItem.url;
        name = aItem.name;
    }
    if (!name) name = url;
    var item = {
        url: url,
        name: name
    };
    return flock.favorites.createFavorite(item, aDetails);
    
    //flock.favorites.service.createFavorite(url, {
    //    name: name,
    //    fields: flock.favorites.properties.FIELD_NAME
    //});
    //return new flock.favorites.Favorite({url: url, name: name});
}
flock.favorites.updateOrCreateFavorite = function (aItem, aDetails) {
    var fav = flock.favorites.getFavorite(aItem);
    if (fav) {
        flock.favorites.editItem(fav, aItem, aDetails);
        return fav;
    }
    return flock.favorites.createFavorite(aItem, aDetails);
}
flock.favorites.createFavorite = function (aItem, aDetails) {
    var saveIt=true;
    var props = {local: true, private: false};
    if (flock_getCharPref('flock.favorites.webservice.id') != '') {
        if (flock_getBoolPref('flock.favorites.shareByDefault')) {
            if (flock_getBoolPref('flock.favorites.privateByDefault') && flock.favorites.supportsField('private')) {
                props = {local: false, private: true};
            } else {
                props = {local: false, private: false};
            }
        }
    }

    var url = null;
    if (typeof aItem == "string") {
        url = aItem;
    }
    else if (aItem.url) {
        url = aItem.url;
    }

    if (url.substring(0,5) == 'feed:' || url.substring(0,6) == 'feeds:') {
        props.feed = true;
    }

    dojo.lang.mixin( props, aItem );

    if (aDetails) {
        saveIt = flock.favorites.editDialog(aItem, props, aDetails);
    }

    if (saveIt) {
        props.fields = flock.favorites.fields(props);
        flock.favorites.service.createFavorite(props.url, props);
        return flock.favorites.getFavorite(props);
    } else {
        return false;
    }
    
};

flock.favorites.createFeedInFavorite = function (aItem, aFavorite) {
    var props = aItem;
    var fav = flock.favorites.getFavorite(aFavorite);
    props.feed = true;
    props.fields = flock.favorites.fields(props);
    XXX('FEEED');
    dd(props);
    flock.favorites.service.createFeedInFavorite(props.url, props, fav.url);
}

flock.favorites.updateFeedsForFavorite = function (aFeedList, aFavorite) {
    var fav = flock.favorites.getFavorite(aFavorite);
    flock.favorites.clearFeedsInFavorite(aFavorite);
    var feeds = aFeedList;
    var feedUrls = feeds.map(function (aVal) {
        return aVal.url;
    });
    
    // this is implemented as a callback for some reason...
    var prioritizeListener = {
        onComplete: function (aCount, aFeedList) {
            aFeedList.forEach(function (aVal) {
                var feed = new flock.favorites.Feed(aVal);
                for (var i = 0; i < feeds.length; ++i) {
                    if (feeds[i].url == feed.url) {
                        feed = feeds[i];
                        break;
                    }
                }
                flock.favorites.createFeedInFavorite(feed, fav);
            });
        }
    };
       
    flock.feed.service.prioritizeFeeds(
        feedUrls.length, 
        feedUrls, 
        prioritizeListener
    );
    
}

flock.favorites.clearFeedsInFavorite = function (aFavorite) {
    var fav = flock.favorites.getFavorite(aFavorite);
    fav.feeds.forEach(function (aVal) {
        flock.favorites.service.removeFeedFromFavorite(aVal.url, fav.url);
    });
}



flock.favorites.isFavorite = function (aItem) {
    return (flock.favorites.getFavorite(aItem) != null);
}
// XXX fill
flock.favorites.favoriteHasFeeds = function (aFav) {
    // disabling hasFeeds
    return false;
    /*
    var fav = flock.favorites.getFavorite(aFav);
    if (!fav) return false;
    return fav.hasFeeds;
    */
}

// Feeds
flock.favorites.getFeed = function (aSomething) {
    if (!aSomething) return null;
    if (aSomething.isFeed) {
        return aSomething;
    }
    if (typeof aSomething == "string") {
        // try to get it as a url
        if (flock.favorites.service.isFeed(aSomething)) {
            return new flock.favorites.Feed({
                url: aSomething
            });
        }
    }
    if (aSomething.url) {
        if (flock.favorites.service.isFeed(aSomething.url)) {
            return new flock.favorites.Feed(aSomething);
        }
    }
    if (flock.rdf.isResource(aSomething)) {
        var str = aSomething.ValueUTF8;
        if (flock.favorites.service.isFeed(str)) {
            return new flock.favorites.Feed({url: str});
        }
    }
    return null;
}
// XXX fill
flock.favorites.getOrCreateFeed = function (aItem) {

}
flock.favorites.isFeed = function (aItem) {
    return (flock.favorites.getFeed(aItem) != null);
}




flock.favorites.showSharingDialog = function () {
    window.openDialog('chrome://browser/content/flock/favorites/favoritesSharing.xul', 'Favorites Sharing', 'modal');
}



flock.favorites.Collection = function (aProps) {
    flock.Base.call(this, aProps);
}
dojo.inherits(flock.favorites.Collection, flock.Base);
dojo.lang.extend(flock.favorites.Collection, {
    name: null,
    isCollection: true,
    resource: null,
    _items: null,
    get items() {
        if (this._items) return this._items;
        var favs = flock.favorites.service.getCollectionFavorites(this.name);
        var out = [];
        while (favs.hasMoreElements()) {
            var item = favs.getNext();
            if (flock.favorites.isFeed(item)) {
                out.push(flock.favorites.getFeed(item));
            }
            else {
                out.push(flock.favorites.getFavorite(item));
            }
        }
        this._items = out;
        return out;
        // recurse through rdf children and return them as a list of objects
    },
});

flock.favorites.Favorite = function (aProps) {
    flock.Base.call(this, aProps);
}
dojo.inherits(flock.favorites.Favorite, flock.Base);
dojo.lang.extend(flock.favorites.Favorite, {
    url: null,
    name: null,
    // alias title to name
    get title() { return this.name; },
    set title(aVal) { this.name = aVal; },
    tags: null,
    description: null,
    favicon: null,
    isFavorite: true,
    load: function () {
        var props = flock.favorites.service.getFavoriteProperties(this.url);
        for (p in props) {
            this[p] = props[p];
        }
    },
    get hasFeeds() {
        return (this.feeds.length > 0);
    },
    _feeds: null,
    get feeds() {
        if (this._feeds) return this._feeds;
        var dummyVar = {};
        var feeds = flock.favorites.service.getFeedsInFavorite(
            this.url, 
            dummyVar
        );
        var feedList = [];
        for (var i = 0; i < feeds.length; ++i) {
            feedList.push(flock.favorites.getFeed(feeds[i]));
        }
        this._feeds = feedList;
        return feedList;
    },
    toTransferData: function () {
        if (this.name == null) this.load();
        var data = {}
        data['text/unicode'] = this.url,
        data['text/x-moz-url'] = this.url + "\n" + this.name;
        data['text/html'] = "<a href='" + this.url + "'>" + this.name + "</a>";
        return data;
    },
    
});

flock.favorites.Feed = function (aProps) {
    flock.favorites.Favorite.call(this, aProps);
}
dojo.inherits(flock.favorites.Feed, flock.favorites.Favorite);
dojo.lang.extend(flock.favorites.Feed, {
    isFeed: true,
    get feeds() {
        return [];
    },
    get posts() {
        var maxNumPosts = {value : 20};
        var posts = flock.feed.service.getFeedData(this.url, maxNumPosts);
        return posts.map(function (aVal) {
            return {
                url: aVal.link,
                name: aVal.title,
                date: new Date(aVal.datevalue)
            };
        });
    },
});


// favicon stuff

flock.favorites.loadFavIcon = function (aURL, aFavIconURL) {
    var fav = flock.favorites.getFavorite(aURL);
    // ignore non-favorites
    if (!fav) return;
    fav.load();
    
    // we cool, it is there
    if (fav.favicon && fav.favicon.substr(0, 5) == "data:") return;

    
    var chan = flock.xpcom.ioService.newChannel(aFavIconURL, null, null);

    //var listener = new bookmarksFavIconLoadListener (aURL, aFavIconURL, chan);
    var listener = new flock.favorites.FavIconLoadListener(fav, aFavIconURL, chan, {"debug": true});
    chan.notificationCallbacks = listener;
    chan.asyncOpen(listener, null);
}

flock.favorites.FavIconLoadListener = function (aFav, aFavIconURL, aChannel, aOpts) {
    this.mFav = aFav;
    this.mURI = aFav.url;
    this.mFavIconURL = aFavIconURL;
    this.mCountRead = 0;
    this.mChannel = aChannel;
    
    flock.xpcom.Supports.call(this, aOpts);
    this.interfaces.push(Components.interfaces.nsIInterfaceRequestor);
    this.interfaces.push(Components.interfaces.nsIRequestObserver);
    this.interfaces.push(Components.interfaces.nsIChannelEventSink);
    this.interfaces.push(Components.interfaces.nsIProgressEventSink);
    this.interfaces.push(Components.interfaces.nsIStreamListener);
}
dojo.inherits(flock.favorites.FavIconLoadListener, flock.xpcom.Supports);
dojo.lang.extend(flock.favorites.FavIconLoadListener, {
    // XXX andy: most of this is a direct yank from bookmarks.js for now
    //           because the interfaces are so hardcoded
    mFav: null,
    mURI: null,
    mFavIconURL: null,
    mCountRead: null,
    mChannel: null,
    mBytes: [],
    mStream: null,

    updateFavIcon: function (aMimeType, aIconData, aIconDataLen) {
        var data = "data:";
        if (aIconData) {
            iconData = String.fromCharCode.apply(null, aIconData);
            data += aMimeType;
            data += ";base64,";
            data += flock.xpcom.base64Service.encode(iconData);
        }
        flock.favorites.editItem(this.mFav, {
            favicon: data,
        });
    },

    // nsIInterfaceRequestor
    getInterface: function (iid) {
        try {
            return this.QueryInterface(iid);
        } catch (e) {
            throw Components.results.NS_NOINTERFACE;
        }
    },

    // nsIRequestObserver
    onStartRequest: function (aRequest, aContext) {
        this.mStream = Components.classes['@mozilla.org/binaryinputstream;1'].createInstance(Components.interfaces.nsIBinaryInputStream);
    },
    onStopRequest : function (aRequest, aContext, aStatusCode) {
        var httpChannel = this.mChannel.QueryInterface(Components.interfaces.nsIHttpChannel);
        if ((httpChannel && httpChannel.requestSucceeded) &&
             Components.isSuccessCode(aStatusCode) &&
             this.mCountRead > 0) {
            var dataurl;
            // XXX - arbitrary size beyond which we will not store a favicon.  This is /extremely/
            // generous, and is probably too high.
            if (this.mCountRead > 16384) {
                dataurl = "data:";      // hack meaning "pretend this doesn't exist"
            } 
            else {
                // get us a mime type for this
                var mimeType = null;

                const nsICategoryManager = Components.interfaces.nsICategoryManager;
                const nsIContentSniffer = Components.interfaces.nsIContentSniffer;

                var catMgr = Components.classes["@mozilla.org/categorymanager;1"].getService(nsICategoryManager);
                var sniffers = catMgr.enumerateCategory("content-sniffing-services");
                while (mimeType == null && sniffers.hasMoreElements()) {
                    var snifferCID = sniffers.getNext().QueryInterface(Components.interfaces.nsISupportsCString).toString();
                    var sniffer = Components.classes[snifferCID].getService(nsIContentSniffer);

                    try {
                        mimeType = sniffer.getMIMETypeFromContent (this.mBytes, this.mCountRead);
                    } catch (e) {
                        mimeType = null;
                        // ignore
                    }
                }
            }
            // XXX andy: this is where I am changing things, aka
            //           "where the magic happens"
            if (mimeType == null) {
                this.updateFavIcon(null, null, 0);
            } 
            else {
                this.updateFavIcon(mimeType, this.mBytes, this.mCountRead);
            }
        }

        this.mChannel = null;
    },

    // nsIStreamObserver
    onDataAvailable : function (aRequest, aContext, aInputStream, aOffset, aCount) {
        // we could get a different aInputStream, so we do not save this;
        // it is unlikely we will get more than one onDataAvailable for a
        // favicon anyway
        this.mStream.setInputStream(aInputStream);
        
        var chunk = this.mStream.readByteArray(aCount);
        this.mBytes = this.mBytes.concat(chunk);
        this.mCountRead += aCount;
    },

    // nsIChannelEventSink
    onChannelRedirect : function (aOldChannel, aNewChannel, aFlags) {
        this.mChannel = aNewChannel;
    },

    // nsIProgressEventSink: the only reason we support
    // nsIProgressEventSink is to shut up a whole slew of xpconnect
    // warnings in debug builds.  (see bug #253127)
    onProgress : function (aRequest, aContext, aProgress, aProgressMax) { },
    onStatus : function (aRequest, aContext, aStatus, aStatusArg) { }
});

