var firstRunOverlay = {};
firstRunOverlay.launchWizard = function() {
    window.openDialog("chrome://fbranding/content/firstRunWizard.xul", 
        "FlockFirstRunWizard", "all,centerscreen,titlebar,dependent");
}

top.addEventListener("load", function() {
    var firstRunForBrowser = flock.firstrun.isFirstRunForComponent("browser_startup");
    var firstRunForFeeds = flock.firstrun.isFirstRunForComponent("feeds_startup");
    if(firstRunForBrowser) {
        flock_setIntPref("flock.first_run.date", Date.now() / 1000);
    }
    if(firstRunForBrowser || firstRunForFeeds) {
        var firstRunUrl = flock_getCharPref('flock.first_run.url');
        if (firstRunUrl) gBrowser.addTab(firstRunUrl);
        //launch the first run wizard
        window.setTimeout("firstRunOverlay.launchWizard();",0);
    }
}, false);

function revertToOriginalToolbar() {
    var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].
        getService(Components.interfaces.nsIRDFService);
    var ds = rdfService.GetDataSource("rdf:local-store");
    var node = rdfService.GetResource("chrome://browser/content/browser.xul#nav-bar");
    var props=ds.ArcLabelsIn(node);
    while(props.hasMoreElements()){
        var prop=props.getNext();
        var source=ds.GetSource(prop,node,true);
        ds.Unassert(source,prop,node);
    }
}

function checkIfBuzzardUpgrade() {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
        .getService(Components.interfaces.nsIPrefBranch);

    // LOGIC: we only are doing a buzzard upgrade if the key doesn't exist

    try {
        var browserStartupKey = "flock.firstrun.components.browser_startup.completed";
        var feedsStartupKey = "flock.firstrun.components.feeds_startup.completed";
        var browserKeyExists = prefs.getBoolPref(browserStartupKey);
        prefs.getBoolPref(feedsStartupKey);
    } catch (e) { 
	if(browserKeyExists) {
            //Buzzard upgrade if the browser first run ran, but feeds first run has not
            prefs.setBoolPref("flock.favorites.enableToolbarSelector", true);
            revertToOriginalToolbar();
	}
    }
}

checkIfBuzzardUpgrade();
